//+------------------------------------------------------------------------------+ 
//|                           Terminator vTSD-4.11.mq4                           | 
//+------------------------------------------------------------------------------+
//|  Private version based on the following EA:                                  |
//|                                                                              |
//|                           DLM1.1 of Alejandro Galindo, http://elCactus.com   |
//|                           Terminator v2.02 of Tom Maneval                    |
//|                           Phoenix of Hendrick Stam                           |
//|                                                                              |
//|           Security Mods, Margin Protection, Phoenix Implementation,          |
//|             Dinamic range calculator, Swap Trading Direction and             |
//|                        several others mods done by:                          |  
//|                                                                              |
//|                                 Project1972                                  |
//|                   and a special collaboration of Tom Maneval                 |
//|                                                                              |
//|    Copyright  Project1972 for http://www.forex-tsd.com Elite Section        |
//|                                                                              |
//|     You are NOT ALLOWED to distribute this EA in any public forum            |
//|                                                                              |
//|             WARNING, Risky Martingale EA, Use it at your risk                |
//|     Current default Settings were determined after many months of testing    |
//|                             Use on H1 Timeframe                              |
//+------------------------------------------------------------------------------+
#property copyright "Copyright  2005,2006 Alejandro Galindo, Tom Maneval and Project1972"
#property link      "http://www.forex-tsd.com"

extern int    Manual=0;                      // If set to one then it will not open new trades but it will continue with already opened positions
extern bool   CloseAllOpenTradesNow=False;   // WARNING If true, then the expert will close all open trades NOW and will not open new ones.
extern bool   CloseAllProfitTradesNow=False; // If true, we will close all trades with at least MinPipsProfit
extern int    MinPipsProfit=22;              // Minimal Profit to execute CloseAllProfitTradesNow
//--------------------------------------------------------------------------------------------------------------------------------------------
//-- Soft Account Protection --- If any of of those following alarm trigger EA will stop opening new trades but it don't generate losses------
//--------------------------------------------------------------------------------------------------------------------------------------------
extern int    ForceAccountProtection=0;   // If set to one then AccountProtection function will be active all the time.
extern int    FloatingLossProtection=75;  // Percent of FLOATING LOSS to stop opening new positions after closed ones(Percent of Balance)
extern double MarginProtection  = 75;     // Percent of free margin to stop opening new positions after closed ones
extern double MarginProtection2 = 55;     // Percent of free margin to START AccountProtection Function
extern bool   SpreadProtection  = True;   // If the spread is widen than normal (News time) we will not open positions or continue positions until it normalize
extern int    PipTolerance      = 2;      // value in pips over normal spread to activate the SpreadProtection
// WARNING, the value of normal spread is taken during the initialization, Start the EA ONLY on calm markets or the value of normal spread can be wrong 
//----------------------------------------------------------------------------------------------------------------------------------------------
//-- WARNING -- Hard Account Protection --- WARNING-- If one of those folowing alarm trigger EA WILL CLOSE all opened positions at Market-------
//-- WARNING - It can generate extreme losses and are intended for limit a further loss in a strong trending market against our positions-------
//----------------------------------------------------------------------------------------------------------------------------------------------
extern bool   EquityProtection=False;                   // if true, then the expert will protect the account equity to the percent specified
extern int    AccountEquityPercentProtection= 50;      // percent of the account Equity left to activate a hard stop loss on a set of trades
extern bool   AccountMoneyProtection=False;            // if true, then the expert will protect the account money to the amount specified
extern double AccountMoneyProtectionValue= 500.00;   // Amount of Equity money To Trigger a Hard Stop Loss on ALL trades.This is a final Stop loss.

//===================================================================================================================================================
extern double Lots              = 0.01;     // We start with this lots number
extern double LotIncreaseFactor = 1.5;       // increase Martingale lots based on this multiplier
extern bool   UseFibonacciProgression=False;// If true we will use a Fibonacci algorithm in the martingale progression
extern double StopLoss          = 0;       // StopLoss
extern double Trailing_Stop     = 15;      // Pips to trail the StopLoss
extern double BreakevenTrail    = 20;      // Pips earned to start to trail the StopLoss
extern double OpenOrders_Before_CloseAll    = 30; // Number of Open Orders before to start CloseAll function
//===================================================================================================================================================
extern int    MaxTrades            =40;     // Maximum number of orders to open
extern int    AccountProtection    =0;      // If one the account protection will be enabled, 0 is disabled
extern int    AllSymbolsProtect    =0;      // If one will check profit from all symbols, if zero only this symbol
extern int    OrderstoProtect      =0;      // This number subtracted from MaxTrades is the number of open orders to enable the account protection.
                                            // Example: (MaxTrades=10) minus (OrderstoProtect=3)=7 orders need to be open before account protection is enabled.

extern bool   mm=False;                      // if True the lots size will increase based on account size (I don't recomend use MM with a martingale EA)
extern double risk=0.1;                     // risk to calculate the lots size (only if mm is enabled)
extern int    MagicNumber=710522;           // Magic number for the orders placed
extern int    HedgeMagicNumber=710529;           // Magic number for the orders placed
extern bool   TradePositiveSwapOnly=True;  // If true we will trade only in the direction of positive interest, if false, both ways                                         
extern int    FixedDirection       =0;      // 0=Both Ways, 1= Longs only 2= Short Only,  if different of 0 then TradePositiveSwapOnly is override                                        
extern bool   DontTradeOnFriday=False;      // If true we will not start new positions on Friday (This is because some brokers don't want open trades over the weekend)
extern bool   PrefSettings     = False;      // If PrefSettings=true we will look for predefined settings for each symbol in the expert initialization function.
//
//================================= Enter Confirmation =============================================================================
//
extern bool   Use_EnterConfirmation=True;     // If true we will use a signal to confirm each position of the martingale progression
extern double Timeframe1           = 0;      // TimeFrame to use in the enter indicator
//                                            // 0 for actual TF or 1,5,15,30,60,240,1440 for 1 minute,5,15,30,60 minutes,240,1440 for 4H and Diary Timeframe
//=============================== End Enter Confirmation ===========================================================================
//
//=============================== Exit Confirmation =============================================================================
//
extern bool   Use_ExitConfirmation=True;     // If true we will use a signal to exit each position if it is in profit
extern double Timeframe2           = 0;     // 0 for actual TF or 1,5,15,30,60,240,1440 for 1 minute,5,15,30,60 minutes,240,1440 for 4H and Diary Timeframe
//
//============================== End Exit Confirmation ==========================================================================
//
//
//=================================AutoSetup Parameters==============================================================================================
//
//   If AutoSetup=true Then the value of Pips, Take Profit, and Secure Profit are taken directly from the chat by a Dinamic Range Calculator
//   If false you have to set Pips, Take Profit, and Secure Profit manually.
//
extern bool   AutoSetup       = True;	   //Set to false if you want to set Pips, Take Profit, and Secure Profit manually.
//
extern double SafeRangeFactor = 1;      // Used to multiply the Average Diary Range in order to be safe
extern double SafeMinRange    = 400;      // Safe Minimal Range in this Symbol, Used to replace the value of Safe Trading Range if it is below this value
//                                        // or the Historical Diary Data doesn't exist or is corrupted.
//Example, if the Average Diary Range is 100 pips and SafeRangeFactor=1.9 then we will operate with a 100x1.9 = 190 pips of range
extern double TakeProfitMT   =1000;          // TakeProfit calculation Pips*TakeProfitMT.  Should be more than 1 but probably not more than 2. Example 1.75
extern double SecureProfitMT =1.5;        // PipsSecureProfit calculation Pips*PipMultiple. Should be between 1 and 2. Example 1.1
//
//==================================Manual Parameters(If AutoSetup=False)=================================================================================================================
//
extern double TakeProfit1     =30;           // Profit Goal for the First order opened
extern int    Pips1           =20;           // Distance in Pips from first order to second
extern double TakeProfit2     =30;           // Profit Goal for the 2^ order opened
extern int    Pips2           =20;           // Distance in Pips from 2^ order to 3^
extern double TakeProfit3     =30;           // Profit Goal for the 3^ order opened
extern int    Pips3           =20;           // Distance in Pips from 3^ order to 4^
extern double TakeProfit4     =30;           // Profit Goal for the 4^ order opened
extern int    Pips4           =20;           // Distance in Pips from 4^ order to 5^
extern double TakeProfit5     =30;           // Profit Goal for the 5^ order opened
extern int    Pips5           =20;           // Distance in Pips from 5^ order to 6^
extern double TakeProfit6     =30;           // Profit Goal for the 6^ order opened
extern int    Pips6           =20;           // Distance in Pips from 6^ order to 7^
extern double TakeProfit7     =30;           // Profit Goal for the 7^ order opened
extern int    Pips7           =20;           // Distance in Pips from 7^ order to 8^
extern double TakeProfit8     =30;           // Profit Goal for the 8^ order opened
extern int    Pips8           =20;           // Distance in Pips from 8^ order to 9^
extern double TakeProfit9     =30;           // Profit Goal for the 9^ order opened
extern int    Pips9           =20;           // Distance in Pips from 9^ order to 10^ and following orders
extern double TakeProfit10    =30;           // Profit Goal for the 10^ and following order opened 
extern int    PipsSecureProfit=10;           // If profit made is bigger than SecureProfit we close the orders


//
extern int  OpenOrdersBasedOn=1;          // Method to Open Positions
//

extern int PeriodTrading = 0; // za "Trend-Filtera" 
//
extern bool       UseHedge       = False;  // Places reverse order with PipStep order.
extern double     HedgeLotFactor = 1;     // Hedge order Lots will be increase by this factor.
extern int        HedgeTakeProfit= 12;
extern int        HedgeStoploss  = 5;
//
//============================== End Exit Confirmation ==========================================================================
//

//=================================== Variables Initialization ==================
//
int  OpenOrders=0,cnt=0,trendtype=0,TrendType=0;
int  slippage=3,WorstRange=0,MinTS=0;
double sl=0, tp=0, StopTrading=0, StopTrading2=0, ProtectionActivate=0;
double BuyPrice=0, SellPrice=0, TakeProfit=0;
double lotsi=0, mylotsi=0, Pips=0,Spread=0,WorstSpread=0,NormalSpread=0;
double TotalSwap=0,TotalCommission=0;
double TotalProfit=0;
int mode=0,myOrderType=0,myOrderTypetmp=0,Stoch1=0,Stoch2=0;
bool ContinueOpening=True;
double LastPrice=0;
int  PreviousOpenOrders=0,EnterConfirmation=0,ExitConfirmation=0;
double SecureProfit=0,Pips_even=0,MinLots=0,LotStep=0,MaxLots=0;
double VariableSpread=0; 
double Profit=0, swaplong=0, swapshort=0;
int LastTicket=0, LastType=0, DontContinue=0;
double LastClosePrice=0, LastLots=0;
double Pivot=0, DontStart=0, DontStart2=1;
double PipValue=0, TrendingMarket=1;
bool AccountisNormal,Reversed=False,DinamicRangeCalc=false;
string text="",text2="",TradeDirection="",TrendTxt="";
string text3="",text4="",WeTradeIt="Both ways",AccountText="";
string text6="",OrdersBasedOn="";
double tmp=0, SafeTradingRange=0;
double iTmpH=0,DnTrendVal=0,UpTrendVal=0,TrendVal=0;
double iTmpL=0,SecureProfit2=0;
int RSX_Period=17,lotsize;
//
//================================End Variables Initialization==================
//
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  

NormalSpread=(Ask-Bid)/Point;
return(0);

}

  
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {   
   int cnt=0;
   swaplong=NormalizeDouble(MarketInfo(Symbol(),18),2);
   swapshort=NormalizeDouble(MarketInfo(Symbol(),19),2);
   MinTS=NormalizeDouble(MarketInfo(Symbol(),14),0);
   MinLots=NormalizeDouble(MarketInfo(Symbol(),23),2);
   LotStep=NormalizeDouble(MarketInfo(Symbol(),24),2);
   MaxLots=NormalizeDouble(MarketInfo(Symbol(),25),2);
   lotsize=MarketInfo( Symbol(), MODE_LOTSIZE );
   PipValue=MarketInfo(Symbol(),16);
   if (PipValue==0) { PipValue=5; }
   if (lotsize==100000){AccountisNormal=True;} else {AccountisNormal=False;}
   if (lotsize==10000){AccountisNormal=False;}
   if (AccountisNormal==True) {AccountText="Standart";} else {AccountText="Mini";}
   Spread=(Ask-Bid)/Point;
   if (MinTS>Trailing_Stop) {Trailing_Stop=MinTS;}
   
   //************** TREND FILTER ******************************************************************
   
   double MA3_0 = iMA(NULL, PeriodTrading, 3, 0, MODE_SMA, PRICE_CLOSE, 0);    // Tuk promeniam
   double MA3_1 = iMA(NULL, PeriodTrading, 3, 0, MODE_SMA, PRICE_CLOSE, 1);    // perioda na
   double MA20_0 = iMA(NULL, PeriodTrading, 20, 0, MODE_SMA, PRICE_CLOSE, 0);  // trend-filtera
   double MA20_1 = iMA(NULL, PeriodTrading, 20, 0, MODE_SMA, PRICE_CLOSE, 1);  // ot tvardo "4h"
   double MA50_0 = iMA(NULL, PeriodTrading, 50, 0, MODE_SMA, PRICE_CLOSE, 0);  // na "PerodTrading"
   double MA50_1 = iMA(NULL, PeriodTrading, 50, 0, MODE_SMA, PRICE_CLOSE, 1);  //
   double MA100_0 = iMA(NULL, PeriodTrading, 100, 0, MODE_SMA, PRICE_CLOSE, 0);//
   double MA100_1 = iMA(NULL, PeriodTrading, 100, 0, MODE_SMA, PRICE_CLOSE, 1);//
   TrendType=0;
   
   
   //if (MA100_0<MA100_1 && MA50_0<MA50_1 && MA20_0<MA20_1 && MA3_0<MA3_1 && MA3_0<MA20_0) {TrendType=1;} //downtrend
   //if (MA100_0>MA100_1 && MA50_0>MA50_1 && MA20_0>MA20_1 && MA3_0>MA3_1 && MA3_0>MA20_0) {TrendType=2;} //uptrend
   if (MA3_0<MA3_1) {TrendType=1;} //downtrend  * opit napravo da se eliminira
   if (MA3_0>MA3_1) {TrendType=2;} //uptrend    * trend-filtera
   
   
   
   if (Spread>WorstSpread) {WorstSpread=Spread;}
   if (AccountisNormal)
   {
	  if (mm) 
	  { 
	   if (MinLots==1) { lotsi=MathFloor(AccountBalance()*risk/100000); }
	   if (MinLots==0.1) { lotsi=MathFloor(AccountBalance()*risk/10000)/10; }
	   if (MinLots==0.01) { lotsi=MathFloor(AccountBalance()*risk/1000)/100; }
	  } 
		else { lotsi=Lots; }
   } else 
   {  // then is mini
    if (mm) 
	  { 
	   if (MinLots==1) { lotsi=MathFloor(AccountBalance()*risk/10000); }
	   if (MinLots==0.1) { lotsi=MathFloor(AccountBalance()*risk/1000)/10; }
	   if (MinLots==0.01) { lotsi=MathFloor(AccountBalance()*risk/100)/100; }
	  } 
		else { lotsi=Lots; }
   }
   if (lotsi>MaxLots){ lotsi=MaxLots; }
   if (lotsi<MinLots){ lotsi=MinLots; }
  
   OpenOrders=0;
   for(cnt=0;cnt<OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	  {				
	  	  OpenOrders++;
	  }
   }     
   

// 
//======================================SECURITY FUNCTIONS======================================================================= 
//
  if (AccountMoneyProtection==true && AccountEquity()< AccountMoneyProtectionValue)
   {
    text3 = "Closing orders because account money protection was triggered.";
    Print("Closing orders because account money protection was triggered. Balance: ",AccountBalance()," Equity: ",AccountEquity());
    CloseAll();
    ContinueOpening=False;
    DontStart=1;
   }
//
//-----------------------Account equity protection-------------------------------------------------------------------------------- 
//
   if (EquityProtection==true && AccountEquity()<=AccountBalance()*AccountEquityPercentProtection/100) 
	 {
	 text3 = "Closing orders because account equity protection was triggered.";
	 Print("Closing orders because account equity protection was triggered. Balance: ",AccountBalance()," Equity: ", AccountEquity());	 
	 CloseAll();
	 ContinueOpening=False;
	 DontStart=1;
   }
//
// if we dont trade at fridays we stop opening new positions
//
 DontStart2=0; text4="";
    
    if (CloseAllOpenTradesNow==True) {
	 text3 = "Closing orders because CloseAllOpenTradesNow=True";	 
	 CloseAll();
	 ContinueOpening=False;
	 DontStart=1;
   }
//

//-----------------IF ONE ORDER IS CLOSED WE CLOSED THE REMAINED-----------------------------------
//
  if (PreviousOpenOrders>OpenOrders && OpenOrders>OpenOrders_Before_CloseAll) {CloseAll();}// Add by NIKSAN_GO

//-----------------------------------FREE MARGIN PROTECTION---------------------------------------------
//
   if (AccountFreeMargin() < (AccountBalance()*MarginProtection/100)){ StopTrading=1; }
   else { StopTrading=0; }
   if (AccountBalance()-AccountEquity() > (AccountBalance()*FloatingLossProtection)/100){ StopTrading2=1; }
   else { StopTrading2=0; }
//------------------------------------------------------------------------------------------------------
//
//----------------------- TimeFilter Function ----------------------------------------------------------  


///
///------------------- IF CONTINUE OPENING---------------------------------------------------------------
   
   PreviousOpenOrders=OpenOrders;
   if (OpenOrders>=MaxTrades) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }
   if (OpenOrders==0 && Manual==1 || StopTrading==1 || StopTrading2==1 || DontStart==1 || DontStart2==1 )
   {
	  ContinueOpening=False;
   } 
       LastPrice=0; //Add by NIKSAN_GO
   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode=OrderType();	
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY) { myOrderType=2; }
			if (mode==OP_SELL) { myOrderType=1;	}
		 }
	  }
   }
   if (AutoSetup==true)
   {
      
      SafeTradingRange=DinamicRangeCalculation();
      Pips=MathCeil(SafeTradingRange/MaxTrades);
      TakeProfit=(Pips*TakeProfitMT);
      PipsSecureProfit=MathCeil(Pips*SecureProfitMT);
      Print(" SafeTradingRange=",SafeTradingRange," Pips Separation=",Pips," TakeProfit=",TakeProfit," PipsSecureProfit=",PipsSecureProfit);   
   }
   else
   {
    if ( OpenOrders==0 ){ TakeProfit=TakeProfit1; }
    if ( OpenOrders==1 ){ TakeProfit=TakeProfit2; Pips=Pips1; }
    if ( OpenOrders==2 ){ TakeProfit=TakeProfit3; Pips=Pips2; }
    if ( OpenOrders==3 ){ TakeProfit=TakeProfit4; Pips=Pips3; }
    if ( OpenOrders==4 ){ TakeProfit=TakeProfit5; Pips=Pips4; }
    if ( OpenOrders==5 ){ TakeProfit=TakeProfit6; Pips=Pips5; }
    if ( OpenOrders==6 ){ TakeProfit=TakeProfit7; Pips=Pips6; }
    if ( OpenOrders==7 ){ TakeProfit=TakeProfit8; Pips=Pips7; }
    if ( OpenOrders==8 ){ TakeProfit=TakeProfit9; Pips=Pips8; }
    if ( OpenOrders>=9 ){ TakeProfit=TakeProfit10; Pips=Pips9; }
   } 
//
//=============== SWITCH TO OPEN ORDERS BASED ON ===========================================================
//
   if (OpenOrders<1 && Manual==0) 
   {
    
     switch (OpenOrdersBasedOn)
     {
	    	
        case 1:
           myOrderTypetmp=OpenOrdersBasedOnMovingAverage();OrdersBasedOn="OpenOrdersBasedOnMovingAverage";break;	 	           	        
                
	  }



	 
//====================  H4 Ema Trend confirmation  ===================================================
      
       myOrderType=0;
       if (myOrderTypetmp==1 && TrendType==1) {myOrderType=1;}
       if (myOrderTypetmp==2 && TrendType==2) {myOrderType=2;}
//
//==========================Positive Swap Filter======================================================
//
     if (TradePositiveSwapOnly==true)
     {
      if (swapshort<=0 && myOrderType==1) { myOrderType=0;}
      if (swaplong<=0 && myOrderType==2) { myOrderType=0;}
     }
//===========================Direction Filter==========================================================
   if (FixedDirection==1)
   {
     if (myOrderType==1) { myOrderType=0;}
   }
   if (FixedDirection==2)
   {
    if (myOrderType==2) { myOrderType=0;}
   }
  }
//   
//=========================  SWAP CALCULATION ========================================================
//
   if (TradePositiveSwapOnly==true) 
   {
    if (swapshort<=0) { WeTradeIt="only Long Signals";   }
    if (swaplong<=0) { WeTradeIt="only Short Signals";}
    if (swaplong<=0 && swapshort<=0) { WeTradeIt="No Tradeable Pair, no positive Swap";   }
   }
   if (FixedDirection==1){ WeTradeIt="only Long Signals";}
   if (FixedDirection==2){ WeTradeIt="only Short Signals";}
   if (myOrderType==1) { TradeDirection="Short"; }
   if (myOrderType==2) { TradeDirection="Long"; }
   if (myOrderType==0) { TradeDirection="Waiting Signal"; }
   
   if (TrendType==0) { TrendTxt = "Undefined - Ranging"; }
   if (TrendType==1) { TrendTxt = "Downtrend"; }
   if (TrendType==2) { TrendTxt = "Uptrend"; }
//----------------------------------------------------------------------------------------------------
//  
//------- If we have opened positions we take care of them  -------------------------------------------
// 
   double TrailingStop=0;
   Pips_even=Pips;
   
   //Original-----   if (OpenOrders>1 && Use_ExitConfirmation) {TrailingStop=0;} else {TrailingStop=Trailing_Stop;if (BreakevenTrail>0){Pips_even=BreakevenTrail;}}
   if (OpenOrders>OpenOrders_Before_CloseAll && Use_ExitConfirmation) {TrailingStop=0;} else {TrailingStop=Trailing_Stop;if (BreakevenTrail>0){Pips_even=BreakevenTrail;}}//Add by NIKSAN_GO
   //if (PreviousOpenOrders>OpenOrders && OpenOrders>OpenOrders_Before_CloseAll) {CloseAll();}// Add by NIKSAN_GO
   
   cnt=OrdersTotal();
   while(cnt>=0)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) // && Reversed==False) 
	  {
        //Print("Ticket ",OrderTicket()," modified.");	     
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0) 
			  {
				  if ((OrderOpenPrice()-Ask)>=(TrailingStop*Point+Pips_even*Point)) 
				  {						
					 if (OrderStopLoss()>(Ask+Point*TrailingStop) || OrderStopLoss()==0)
					 {					
					    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderClosePrice()-TakeProfit*Point-TrailingStop*Point,0,Purple);
	  					 return(0);	  					
	  				 }
	  			  }
			  }
	  	  }
   
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0) 
	  		 {
			   if ((Bid-OrderOpenPrice())>=(TrailingStop*Point+Pips_even*Point)) 
				{
					if (OrderStopLoss()<(Bid-Point*TrailingStop)) 
					{
					   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderClosePrice()+TakeProfit*Point+TrailingStop*Point,0,Yellow);
                  return(0);
					}
  				}
			 }
	  	  }
   	}
      cnt--;
   }
//
//
//==========================================Secure Profit Level 2(Emergency Exit) ==============================================     
//
//
   ProtectionActivate=0;
   if (OpenOrders>=(MaxTrades-OrderstoProtect) && AccountProtection==1) {ProtectionActivate=1;}
   if (AccountFreeMargin() < (AccountBalance()*MarginProtection2/100)) {ProtectionActivate=1;}
   if (ForceAccountProtection==1) {ProtectionActivate=1;}
   if (ProtectionActivate==1)
   {
	  Profit=0;
	  TotalProfit=0;
     LastTicket=0;
	  LastType=0;
	  LastClosePrice=0;
	  LastLots=0;
	  TotalSwap=0;
	  TotalCommission=0;	
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) 
		 {			
			LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{			
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
			   TotalSwap=TotalSwap+OrderSwap();
			   TotalCommission=TotalCommission+OrderCommission();
			}
			if (LastType==OP_SELL) 
			{
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				TotalSwap=TotalSwap+OrderSwap();
				TotalCommission=TotalCommission+OrderCommission();
			}
	  	  }
	  }
	  SecureProfit=PipsSecureProfit*(PipValue*lotsi);
	  SecureProfit=NormalizeDouble(SecureProfit,2);
	  Profit=(NormalizeDouble((Profit*PipValue),2))+TotalCommission;
	  TotalProfit=Profit+TotalSwap+TotalCommission;
	  if (TotalSwap<0) {Profit=TotalProfit;}
	  Print(" SafeTradingRange= ",SafeTradingRange," Pips Separation= ",Pips," TakeProfit= ",TakeProfit," PipsSecureProfit= ",PipsSecureProfit
	  ," SecureProfit=$",SecureProfit," Profit/Loss=$",TotalProfit);
	  if (AllSymbolsProtect==1) { tmp=AccountBalance(); }
	  else { tmp=SecureProfit; }
	  if (Profit>=tmp && OpenOrders>OpenOrders_Before_CloseAll) //Add by NIKSAN_GO
	  {
	     OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);		 
		  CloseAll();
		  ContinueOpening=False;
		  myOrderType=0;
		  return(0);
	  }
   }
//
//========================================= End Secure Profit Level 2(Emergency Exit) ==============================================     
//
//
//==========================================Exit Confirmation Secure Profit Level 1 ================================================
//  
   if (Use_ExitConfirmation && OpenOrders>=1)
   {
	  Profit=0;
	  TotalProfit=0;
     LastTicket=0;
	  LastType=0;
	  LastClosePrice=0;
	  LastLots=0;
	  TotalSwap=0;
	  TotalCommission=0;
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) 
		 {			
			LastTicket=OrderTicket();
			if (OrderType()==OP_BUY) { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{				
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
			   TotalSwap=TotalSwap+OrderSwap();
			   TotalCommission=TotalCommission+OrderCommission();
			}
			if (LastType==OP_SELL) 
			{
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/Point; }
				TotalSwap=TotalSwap+OrderSwap();
				TotalCommission=TotalCommission+OrderCommission();
			}
	  	  }
	  }
	  SecureProfit=PipsSecureProfit*(PipValue*lotsi);
	  SecureProfit=NormalizeDouble(SecureProfit,2);
	  Profit=(NormalizeDouble((Profit*PipValue),2))+TotalCommission;
	  TotalProfit=Profit+TotalSwap+TotalCommission;
	  if (TotalSwap<0) {Profit=TotalProfit;}
	  tmp=SecureProfit*OpenOrders;
	  ExitConfirmation=1;
	  if (Profit>=tmp && OpenOrders>OpenOrders_Before_CloseAll)//Add by NIKSAN_GO
	  {  TrailingStop=15;
	     if (Use_ExitConfirmation) {ExitConfirmation=Exit_Confirmation();}
	     if (ExitConfirmation==1) {OrderClose(LastTicket,LastLots,LastClosePrice,slippage,Yellow);		 
		  CloseAll();
		  ContinueOpening=False;
		  myOrderType=0;
		  return(0);}
	  } else TrailingStop=0;
	  if (CloseAllProfitTradesNow) 
	  {
	    SecureProfit2=MinPipsProfit*(PipValue*lotsi);
	    if (Profit>=SecureProfit2) 
	      {
	       CloseAll();
	       ContinueOpening=False;
		    myOrderType=0;
		    return(0);
		   }
	  }
	   
    }
	    
//================================================End Exit Confirmation Secure Profit Level 1 ==============================================  
//
     
      if (SpreadProtection && Spread>NormalSpread+PipTolerance){DontContinue=1;} else {DontContinue=0;}
      if (OpenOrders==0 && Manual==1) { text="Manual=1, Automatic Starting Disable                  "; }
      else {if (OpenOrders==0 && StopTrading==1) { text="Low Free Margin Available. We will not open new trades";
      if (OpenOrders==0 && StopTrading2==1) { text="Excessive Floating Loss. We will not open new trades"; }}
        else { if (myOrderType==3) { text="No conditions to open trades                         "; }
	   else { text="                                                     "; }}
	   if (DontContinue==1) {text="WIDEN SPREAD - Spread protection is active"; }
	   if (ProtectionActivate==1) { text2="Account Protection is active,   "; }
	     else { text2="                                           ";}}
	     Comment("Normal Spread=",NormalSpread," Actual Spread=",Spread,"  Worst Spread=",WorstSpread,"  PipValue=$",PipValue," Account Type: ",AccountText,"\nSignal used to open orders: ",OrdersBasedOn,text6,"LastPrice=",
	     LastPrice," Previous open orders=",PreviousOpenOrders,"\nSwap Short= ",swapshort," Swap Long= ",swaplong,
	     "\nSwap Profit/Loss on open orders= $",TotalSwap,"\nTotal Commissions on open orders= $",TotalCommission,"\nTotal Profit/Loss on open orders= $",TotalProfit,"\nWe trade it: ",WeTradeIt,
	     "\nContinue opening=",ContinueOpening,"\nOrderType= ",TradeDirection,
	     "\n4H Trend : ",TrendTxt,"\nLots=",lotsi,"\n",text,"\n",text2,"\n",text3,"\n",text4);
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      if (myOrderType==1 && ContinueOpening && DontContinue==0) 
      {	EnterConfirmation=1;
	     if ((Bid-LastPrice)>=Pips*Point || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*Point; }	
		    if (StopLoss==0) { sl=0; }
		    else { sl=SellPrice+StopLoss*Point;  }
		    if (OpenOrders>0) 
		    { if (Use_EnterConfirmation) {EnterConfirmation=Enter_Confirmation();}
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      if (UseFibonacciProgression) {mylotsi=MathRound(MathPow(1.6180339,cnt+1)/MathSqrt(5))*lotsi;}
			 			  else { mylotsi=NormalizeDouble(mylotsi+Lots,2);} 
			 			//else { mylotsi=NormalizeDouble(mylotsi*LotIncreaseFactor,2);} 
		    
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    if (EnterConfirmation==1) 
		    {
		      OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage,sl,tp,"NIK"+MagicNumber,MagicNumber,0,Red);
		      		    		    
		    if(UseHedge==true)
           {  
            OrderSend(Symbol(),OP_BUY,mylotsi*HedgeLotFactor,Ask,slippage,Ask-HedgeStoploss*Point,Ask+HedgeTakeProfit*Point,"NIK_Hedge"+HedgeMagicNumber,HedgeMagicNumber,0,DarkSalmon);
           }
		    
		    
		    return(0);
		    }
	     }
	     
	     
	   }
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------      
      if (myOrderType==2 && ContinueOpening && DontContinue==0) 
      { EnterConfirmation=1;
	     if ((LastPrice-Ask)>=Pips*Point || OpenOrders<1) 
	     { 		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*Point; }	
		    if (StopLoss==0)  { sl=0; }
		    else { sl=BuyPrice-StopLoss*Point; }
		    if (OpenOrders>0) 
		    { if (Use_EnterConfirmation) {EnterConfirmation=Enter_Confirmation();}
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   if (UseFibonacciProgression) {mylotsi=MathRound(MathPow(1.6180339,cnt+1)/MathSqrt(5))*lotsi;}
			 	        else { mylotsi=NormalizeDouble(mylotsi+Lots,2);} 
			 			//else { mylotsi=NormalizeDouble(mylotsi*LotIncreaseFactor,2);} 
		    		    
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    if (EnterConfirmation==1) 
		    {
		      OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage,sl,tp,"NIK"+MagicNumber,MagicNumber,0,Blue);		    
		    
		     if(UseHedge==true)// Add by NIKSAN_GO
           {  
            OrderSend(Symbol(),OP_SELL,mylotsi*HedgeLotFactor,Bid,slippage,Bid+HedgeStoploss*Point,Bid-HedgeTakeProfit*Point,"NIK_Hedge"+HedgeMagicNumber,HedgeMagicNumber,0,DeepSkyBlue);// Add by NIKSAN_GO
           }
		    
		    return(0);}
	     }
      }   

   return(0);
  }

//=============== Function Close all Open Orders ==========================================================================
//
void CloseAll()
{
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();
    bool result = false;
    if ((OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) || AllSymbolsProtect==1)
    {
     switch(type)
     {
      //Close opened long positions
      case OP_BUY       : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_BID),slippage,Blue);
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_ASK),slippage,Red);
                          
     }
    }
    
    if ((OrderSymbol()==Symbol() && OrderMagicNumber() == HedgeMagicNumber))// Add by NIKSAN_GO
    {
     switch(type)
     {
      //Close opened long positions
      case OP_BUY       : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_BID),slippage,DarkSlateBlue);
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_ASK),slippage,DarkViolet);
                          
     }
    }
    
  }
  myOrderType=0;
}
//
//========================= Enter iStochastic Confirmation ==============================================
//
int Enter_Confirmation() 
{    
 int EnterConfirmation=0;    
 double Stoch1=0, Stoch2=0;    
 
 Stoch1= iStochastic(NULL,Timeframe1,5,3,3,MODE_SMA,0,MODE_MAIN,0);
 Stoch2= iStochastic(NULL,Timeframe1,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);    
 if (myOrderType==1 && Stoch1<Stoch2) { EnterConfirmation=1; }  // Confirm SELL Orders
 if (myOrderType==2 && Stoch1>Stoch2) { EnterConfirmation=1; }  // Confirm BUY Orders  
 
 
  /*    double Buy1_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 0);
      double Buy1_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 1, 0);
      double Buy2_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 0);
      double Buy2_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 1);
      double Buy3_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy3_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_SIGNAL, 0);
      double Buy4_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy4_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 1);
      double Buy5_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy5_2 = 80;
      double Buy6_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Buy6_2 = 20;
      double Buy7_1 = iRSI(NULL, 0, 5, PRICE_CLOSE, 0);
      double Buy7_2 = iRSI(NULL, 0, 5, PRICE_CLOSE, 1);
      double Buy8_1 = iMFI(NULL, 0, 5, 0);
      double Buy8_2 = iMFI(NULL, 0, 5, 1);    
      double Sell1_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 0);
      double Sell1_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 1, 0);
      double Sell2_1 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 0);
      double Sell2_2 = iCustom(NULL, 0, "i_Trend", 0, 0, 0, 20, 2, 13, 300, 0, 1);
      double Sell3_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell3_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_SIGNAL, 0);
      double Sell4_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell4_2 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 1);
      double Sell5_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell5_2 = 80;
      double Sell6_1 = iStochastic(NULL, 0, 8, 3, 4, MODE_EMA, 1, MODE_MAIN, 0);
      double Sell6_2 = 30;
      double Sell7_1 = iRSI(NULL, 0, 5, PRICE_CLOSE, 0);
      double Sell7_2 = iRSI(NULL, 0, 5, PRICE_CLOSE, 1);
      double Sell8_1 = iMFI(NULL, 0, 5, 0);
      double Sell8_2 = iMFI(NULL, 0, 5, 1);
           
      if (myOrderType==2 && Buy1_1 > Buy1_2 && Buy2_1 > Buy2_2 && Buy3_1 > Buy3_2 && Buy4_1 > Buy4_2 && Buy5_1 < Buy5_2 && Buy6_1 > Buy6_2 && Buy7_1 > Buy7_2 && Buy8_1 > Buy8_2) { EnterConfirmation=1; }  // Confirm BUY Orders { myOrderTypetmp = 2; }
      if (myOrderType==1 && Sell1_1 < Sell1_2 && Sell2_1 < Sell2_2 && Sell3_1 < Sell3_2 && Sell4_1 < Sell4_2 && Sell5_1 < Sell5_2 && Sell6_1 > Sell6_2 && Sell7_1 < Sell7_2 && Sell8_1 < Sell8_2) { EnterConfirmation=1; }  // Confirm SELL Orders
   */    
 return(EnterConfirmation);
}
//=========================End Enter iStochastic Confirmation ==============================================
//
//========================= Exit iStochastic Confirmation ==============================================
//
int Exit_Confirmation() 
{    
 int ExitConfirmation=0;    
 double Stoch1=0, Stoch2=0;    
 
 Stoch1= iStochastic(NULL,Timeframe2,5,3,3,MODE_SMA,0,MODE_MAIN,0);
 Stoch2= iStochastic(NULL,Timeframe2,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);    
 if (myOrderType==1 && Stoch1>Stoch2) { ExitConfirmation=1; }  // Close SELL Orders   
 if (myOrderType==2 && Stoch1<Stoch2) { ExitConfirmation=1; }  // Close BUY Orders 
 return(ExitConfirmation);
}
//=========================End Exit iStochastic Confirmation ==============================================
//
//=========================DINAMIC RANGE CALCULATION====================================================
int DinamicRangeCalculation()
{
   int RAvg=0, Rmax=0;
   int SafeTradingRange=0;
   int MaxRange=0;
   int i=0;
   i=1;for(;;)
     { 
      i++;
      Rmax   =  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
      RAvg   = RAvg + (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
      if (Rmax>WorstRange) {WorstRange=(Rmax);}
      if (i>719) break;
      }         
   RAvg  = RAvg/720; 
   SafeTradingRange =MathCeil(WorstRange*SafeRangeFactor);
   if (SafeTradingRange<SafeMinRange) {SafeTradingRange = SafeMinRange;}
   text6 =  "\nAverage Day Range: " +  RAvg + "\n"  + 
            "Worst Diary Range  : " +  WorstRange  + "\n" +
            "Safe Trading Range : " +  SafeTradingRange  + "\n";       
return(SafeTradingRange);
}
//=========================END DINAMIC RANGE CALCULATION================================================================
//
//=========================SIGNAL SECTION===============================================================================
//             
// FROM THIS SECTION I WILL INSERT ALL THE POSSIBLE FUNCTIONS TO
// MAKE THE DECISION IF WE START LONG OR SHORT
//
//======================================================================================================================

//--------------------------- OpenOrdersBasedOnTrendRSX ----------------------------------------------------------------
//
int OpenOrdersBasedOnMovingAverage()
{
   int myOrderTypetmp=0;
   double ma;
   
   ma=iMA(NULL,0,12,6,MODE_SMA,PRICE_CLOSE,0);
   
   // sell
   if(Open[1]>ma && Close[1]<ma) myOrderTypetmp=1;
   
   // buy
   if(Open[1]<ma && Close[1]>ma) myOrderTypetmp=2;
   
   return(myOrderTypetmp);
}

